{% extends "logged_in.html" %}

{% block content %}
<h1>Telegram integration</h1>

<h2>@{{ bot.username }}</h2>
<table class="table">
    <tr><th>Name</th><td>{{ bot.first_name }}</td></tr>
    <tr><th>Icon</th><td><img src="{{ bot.profile_photo.url }}" class="profile-pic"/></td></tr>
    <tr><th>Username</th><td><a href="{{ bot.link }}">@{{ bot.username }}</a></td></tr>
    {% if dbot %}
        <tr><th>Token</th><td style="font-size: small">{{ bot.client.token }}</td></tr>
    {% endif %}
    {% if hook.ok %}
        {% if hook.result.url %}
            <tr><th>Webhook</th><td>{{ hook.result.url }}</td></tr>
        {% endif %}
    {% else %}
        <tr><th>Webhook</th><td>Error</td></tr>
    {% endif %}
    <tr><th>Actions</th><td>
        <ul class="buttons">
            {% if dbot %}
                <li><a href="{% url "telegram:bot_remove" bot.client.token %}">Remove</a></li>
                <li><a href="{% url "telegram:bot_compose" %}?token={{ bot.client.token }}">Compose</a></li>

                {% if dbot.enabled %}
                    <li><a href="{% url "telegram:bot_disable" bot.client.token %}">Disable</a></li>
                {% else %}
                    <li><a href="{% url "telegram:bot_enable" bot.client.token %}">Enable</a></li>
                {% endif %}
            {% endif %}
            {% if hook.ok and hook.result.url %}
                <li><a href="{% url "telegram:bot_delete_hook" bot.client.token %}">Delete Webhook</a></li>
            {% endif %}
            <li><a href="{% url "telegram:bot_test" bot.client.token %}">API Test</a></li>
        </ul>
    </td></tr>
</table>

<h2>Commands</h2>
{% if commands is None %}
    <p>Couldn't fetch commands</p>
{% elif not commands %}
    <p>No commands set</p>
{% else %}
    <table class="table">
    {% for command in commands %}
        <tr><th>/{{ command.command }}</th><td>{{ command.description }}</td></tr>
    {% endfor %}
    </table>
{% endif %}

{% if exceptions %}
    <h2>Exceptions</h2>
    <pre>{% for exception in exceptions %}{{ exception }}{% endfor %}</pre>

    <ul class="buttons">
        <li><a href="{% url "telegram:bot_exceptions_clear" bot.client.token %}">Clear</a></li>
    </ul>
{% endif %}


{% if debug_mode_form and user.is_superuser %}
<h2>Debug mode</h2>
<form method="post">
    {% csrf_token %}
    {{ debug_mode_form.as_p }}
    <button type="submit">Save</button>
</form>
{% endif %}


<h2>Advanced</h2>

<form method="post" action="{% url 'telegram:bot_advanced' bot.client.token %}">
    {% csrf_token %}
    {{ advanced_form }}
    <button type="submit">Save</button>
</form>

{% if advanced_bot %}
    <h3>Groups</h3>

    <table class="table">
        <tr><th>Name</th><th>ID</th><th>Approved</th><th>Admin</th><th>Actions</th></tr>
        {% for group in advanced_bot.groups.all %}
            <tr><td>{{ group.name }}</td><td>{{ group.id }}</td><td>{{ group.approved }}</td><td>{{ group.admin }}</td>
            <td>
                <ul class="buttons">
                    {% if not group.approved %}
                        <li><a href="{% url "telegram:bot_advanced_group_approve" bot.client.token group.id %}">Approve</a></li>
                    {% elif not group.admin %}
                        <li><a href="{% url "telegram:bot_advanced_group_make_admin" bot.client.token group.id %}">Make Admin</a></li>
                    {% endif %}
                    <li><a href="{% url "telegram:bot_advanced_group_delete" bot.client.token group.id %}">Delete</a></li>
                </ul>
            </td>
        {% endfor %}
    </table>
{% endif %}

<h2>Stats</h2>
<table class="table">
    <tr><th>ID</th><th>Username</th><th>Hits</th><th>Rate</th><th>Blocked</th><th>Queries</th></tr>
    {% for stat in bot.client.query_stats %}
        <tr>
            <td>{{ stat.id }}</td><td>{{ stat.username }}</td><td>{{ stat.count }}</td><td>{{ stat.rate }}</td><td>{{ stat.blocked }}</td>
            <td><ul>
                {% for query in stat.top_queries %}
                    <li>{{ query.1 }} - {{ query.0 }}</li>
                {% endfor %}
            </ul></td>
        </tr>
    {% endfor %}
</table>


{% endblock %}
